# Installation
No installation required. Pleas follow the instructions in DEPENDENCIES.md

# License
The code is provided under the GPLv3+. See LICENSE for further informations.

# Usage
Run the python script `mor_simulator.py` inside of the Firedrake venv
```
$ python mor_simulator.py
```
The script will generate the required folders and simulate the full order system
with the step input described in the journal paper (A Comparison of Second-Order
Model Order Reduction Methods for an Artificial Fishtail), as long as the file
`./results/output_full_step/full_sys.mat` is not exiting.

Running
```
$ python mor_simulator.py --sinus
```
generates the results for the sinusoidal input function, which has been
described in the journal paper. The script will search the file
`./results/output_full_sin/full_sys.mat` in order to determine if a simulation
of the full order system is required.

The results of the scripts are written in the `./results/output_reduced_step/`
(`./results/output_reduced_sin/` for the sinusoidal input). For each used
reduced order `.mat` file (see DEPENDENCIES.md) a sub folder is created. Within
the folder there is a file named like `fish_ext_ROMN_SUB.mat`, where `ROMN`
stands for  the name of the reduced order model and `SUB` can be replaced by the
name of the matrix-set which has been used. This file contains the time, the
reduced order state and the output, generated by the reduced order model. The
`comp_SUB.mat` file is the comparison between the full order model and the
reduced order model and contains the time, the input, the full system output,
the reduced system output and the difference between the outputs. If a
transformation matrix (from the reduced system model to the full system model)
is available the L2-Norm off the state difference is included in this file.
Without a transformation matrix the file contains the L2-Norm of the full system
state. The file `input_SUB` contains the simulation input for the reduced order
system.
